#!/bin/perl 
#A.Fedorov 03-16-2015 modeling of inheritance of genomic IBD segments in generations.
use Storable qw(dclone);

use IO::File;
$| = 1;
$NRE1 =2; #number of recombination events on chr1
@c =();  #array of coordinates of IBD
$g =0; #generation counter
%table =(); #recombination table from genetic_map_chr1_b36.txt file
#STEP1 process genetic map table downloaded from NCBI
for $x (1..22) {
	$file = 'genetic_map_chr'.$x.'_b36.txt'; %{'table'.$x}=();
	open (CHR, "$file") || die;
	$first_line = <CHR>;
	while (<CHR>) {
		chomp($_);
		@lines = split(/\s+/,$_);
		if ($#lines != 2) {
		#	print "problem with recomb file $#lines \n";
		}
		${'table'.$x}{$lines[2]}=$lines[0];
	}
	@{'keys'.$x} = sort{ $a <=> $b } keys(%{'table'.$x});
	${'chr'.$x} = ${'keys'.$x}[$#{'keys'.$x}]; #total CantiMorgans length from the chromosome table
	${'i'.$x} =int(${'chr'.$x}/100);#integer for Step2
	${'rem'.$x} = ${'chr'.$x}%100;  #remainder for Step2
#	print "$x\t$#{'keys'.$x} \t${'chr'.$x}\t${'i'.$x}\t ${'rem'.$x}\n";
	print ${'table'.$x}{${'keys'.$x}[$#{'keys'.$x}]}, "\n";
}

$file = "IBDmodeling_F_". $ARGV[0];
$file2 = "IBDmodeling_L_". $ARGV[0];
open (OUT, ">$file");
open (OUT2, ">$file2");
OUT -> autoflush;
OUT2 -> autoflush;
for $person (1..1000) {
%num_IBD=();
%length_IBD=();
#STEP2 create recombination sites on a genetic chromosomal map
for $y (1..22) {  #loop for chromosomes 1..22
$g=0;
# print "++++++++++++++++++CRHOMOSOME $y +++++++++++++++++++++++";
OUTER:
while ($g < 91) {
#print "\ngeneration $g \n";
$r=int(rand(100)); #random number generator to create average frequency of recombinations equal to 2.78
if($r<${'rem'.$y}) {$NRE1 = ${'i'.$y}+1;}
else {$NRE1 = ${'i'.$y};}
@rec =(); #array for coordinates of meiotic recombination events on the genetic length scale
for $n (1..$NRE1) {
	$r = rand(${'chr'.$y});
	push (@rec, $r);
}
my @rec2 = sort { $a <=> $b } @rec;
#print "@rec2 \n";

#STEP3 map recombination sites on physical chromosome
@pos =(); #positions of recombination points on physical map of the chromosome
@keys = @{'keys'.$y};
%table = %{'table'.$y};
for $m (0..($NRE1-1)) {
	for $n (0..$#keys) {
		if ($rec2[$m] <=$keys[$n]) {$p=$n; last;} #$p stands for position of the recombination site
	}
	$L = $keys[$p] -$keys[$p-1]; #length of the genetic distance segment from the recombination table
	$l =$rec2[$m] - $keys[$p-1];  #length from the start of the IBD block to the recombination point
	if ($L > 0) {$ratio = $l/$L;}
	else {#print "problem with $L \n"; $position = $table{$keys[$p-1]}; 
	}
	$position = int($table{$keys[$p-1]} + ($table{$keys[$p]} - $table{$keys[$p-1]})*$ratio); #positon of recombination site on the physical chromosomal scale
	push(@pos, $position);
}
#print "recombination sites: @pos \n";

#STEP4 create a gamet with ansestral (g0) IBD coordinates
if ($g == 0) {
	@c =();  #array of coordinates of IBD
	$r = int(rand(2)); #random number generator to choose Maternal or Paternal chr1 in the initial person (generation 0)
        if ($r == 0) {$parent = 'm';}
        else {$parent = 'p';}
	for $m (0..($#pos)) {	
		if ($m ==0) {
			$c[$m][0] = "0";
			$c[$m][1] = $pos[$m];
			$c[$m][2] = $parent;
			$parent = &switch($parent);
		}
		else {	$start = $pos[$m-1] +1;
			$c[$m][0] = $start;
			$c[$m][1] = $pos[$m];
			$c[$m][2] = $parent;
			$parent = &switch($parent);
		}
	}
	$z=$#pos;
	$start = $pos[$z] +1;
        $c[$z+1][0] = $start;
	$c[$z+1][1] = $table{$keys[$#keys]};
	$c[$z+1][2] = $parent;

	$g++;
	for $x (0..$#c) {
	#	print "c $c[$x][0]\t$c[$x][1]\t$c[$x][2]\n";
	}
}
else {
	@new =();
	$g++;
	$flag=0; #to skip another parental segment
	$a=0; #counter for elements in array @new
	$r = int(rand(2)); #random number generator to choose Maternal or Paternal chr1 in the initial person (generation 0)
        if ($r == 0) {#print "begining of the gamet is the ansestor chromosome\nSTEPS:\t";
		unshift(@pos, 0);
		for $m (0..($#pos)) {
			if ($flag) {$flag =0; next;}
			$B=$pos[$m]; $E = $pos[$m+1]; if ($m == $#pos) { $E = 100000000000000;}
			for $x (0..$#c) {
				if ($c[$x][0] >= $E) {
				#	print "ST0$B\t"; 
					last;
				}
				elsif ( $c[$x][1] <= $E && $B <= $c[$x][0]) {$new[$a][0] = $c[$x][0]; $new[$a][1] = $c[$x][1]; $new[$a][2] = $c[$x][2]; $a++; 
				#	print "ST1$B\t";
				}
				elsif ($c[$x][1] <= $B) {
				#	print "ST2$B\t";
					next; 
				}
				elsif ( $c[$x][1] < $E && $B >= $c[$x][0] && $B <$c[$x][1]) {$new[$a][0]=$B; $new[$a][1]=$c[$x][1]; $new[$a][2]=$c[$x][2]; $a++;
				#	print "ST3$B\t";
				}
				elsif ( $c[$x][1] >= $E && $B <= $c[$x][0] ) { $new[$a][0] = $c[$x][0]; $new[$a][1] = $E;  $new[$a][2]=$c[$x][2]; $a++;
				#	print "ST4$B\t"; 
					last;
				}
				elsif ( $c[$x][1] > $E && $B > $c[$x][0] ) { $new[$a][0] = $B; $new[$a][1] = $E;  $new[$a][2]=$c[$x][2]; $a++; 
				#	print "ST5$B\t"; 
					last; 
				}
				else {
				#	print "skip$B\t";
				}
			}
			$flag =1;
		}
		#print "\n";
		@c=();
		@c =@{dclone(\@new)};	
	}
	else {#print "Beginning is NOT ancestor chromosome \nSTEPS:\t";
		for $m (0..($#pos)) {
                        if ($flag) {$flag =0; next;}
                        $B=$pos[$m]; $E = $pos[$m+1]; if ($m == $#pos) { $E = 100000000000000;}
                        for $x (0..$#c) {
				if ($c[$x][0] >= $E) {
					#print "ST0$B\t"; 
					last;
				}
                                elsif ( $c[$x][1] <= $E && $B <= $c[$x][0]) {$new[$a][0] = $c[$x][0]; $new[$a][1] = $c[$x][1]; $new[$a][2] = $c[$x][2]; $a++; 
				#	print "ST1$B\t";
				}
                                elsif ($c[$x][1] <= $B) {
				#	print "ST2$B\t";
					next; 
				}
                                elsif ( $c[$x][1] < $E && $B >= $c[$x][0] && $B <$c[$x][1]) {$new[$a][0]=$B; $new[$a][1]=$c[$x][1]; $new[$a][2]=$c[$x][2]; $a++;
				#	print "ST3$B\t";
				}
                                elsif ( $c[$x][1] >= $E && $B <= $c[$x][0] ) { $new[$a][0] = $c[$x][0]; $new[$a][1] = $E;  $new[$a][2]=$c[$x][2]; $a++;
				#	print "ST4$B\t"; 
					last;
				}
                                elsif ( $c[$x][1] > $E && $B > $c[$x][0] ) { $new[$a][0] = $B; $new[$a][1] = $E;  $new[$a][2]=$c[$x][2]; $a++; 
				#	print "ST5$B\t"; 
					last; 
				}
                                else {
				#	print "skip$B\t";
				}
                        }
                        $flag =1;
                }
		#print "\n";
		@c=();
                @c =@{dclone(\@new)};  
	}
	if ($a==0) {
	#		print "at generation $g all IBDs lost \n";
			last OUTER;
	}
}
for $x (0..$#new) { 
#	print "new $new[$x][0]\t$new[$x][1]\t$new[$x][2]\n"; 
}
$ibd =0; #number of IBDs
$ibdL =0; #total length of IBDs
$ibd = $#new; if ($ibd ==-1) {$ibd =0;} else{$ibd=1;}
for $x (0..$#new) {
	if( ($new[$x+1][0] - $new[$x][1])>1000) {$ibd++;}  
	$ibdL +=$new[$x][1] - $new[$x][0];
}
#print "total number of IBDS is $ibd \t length is $ibdL\n";
$num_IBD{$g}+=$ibd; 
$length_IBD{$g}+=$ibdL;
if ($max_g < $g) {$max_g = $g;}
} # end of while $g loop

}#end of chromosome $y loop

#print "max generation is $max_g \n";
print OUT "$person\t";  print OUT2 "$person\t";
for $y (1..$max_g) {
	#print "generation $y\t$num_IBD{$y}\t$length_IBD{$y}\n";
	print OUT "$num_IBD{$y}\t";
	print OUT2 "$length_IBD{$y}\t";
}
print OUT "\n"; print OUT2 "\n";
$max_g =0;
}#loop for persons

sub switch {
	if ($_[0] eq 'p') {$s = 'm';}
	else {$s = 'p';}
	return $s;
}






